import os from'os';import test from'ava';import ntml from'../';import{setTimeout}from'timers';function toMs(a){return 1e3*a[0]+1e-6*a[1]}test('lit-ntml',async(a)=>{console.log('#',os.cpus().length,os.cpus()[0]),a.pass()}),test('render simple Hello, World',async(a)=>{try{const b=ntml(),c=await b`<div>Hello, World!</div>`;a.true('string'==typeof c),a.is(c,'<div>Hello, World!</div>')}catch(b){a.fail()}}),test('render html with async + sync tasks',async(a)=>{try{const b=ntml(),c=new Promise((a)=>a('Hello, World!')),d=await b`
    <section>${()=>'<div>Sync Task Func</div>'}</section>
    <section>${'Sync Task'}</section>
    <section>${async()=>'<div>Async Task Func</div>'}</section>
    <section>${c}</section>
    `;a.true('string'==typeof d),a.is(d,`
    <section><div>Sync Task Func</div></section>
    <section>Sync Task</section>
    <section><div>Async Task Func</div></section>
    <section>Hello, World!</section>
    `.trim())}catch(b){a.fail()}}),test('cached rendered html with ES6 Map cache store + a unique cached name',async(a)=>{try{const b=new Map,c=ntml({cacheStore:b,cacheName:'test'}),d=3e3,e=async()=>new Promise((a)=>setTimeout(()=>a('Hello, delay world!'),d)),f=process.hrtime(),g=await c`<div>${e}</div>`,h=process.hrtime(f),i=process.hrtime(),j=await c`<div>${e}</div>`,k=process.hrtime(i);console.log('#',toMs(h),toMs(k)),a.true('string'==typeof g),a.true(toMs(h)>=d),a.is(g,'<div>Hello, delay world!</div>'),a.true(10>toMs(k)),a.is(j,'<div>Hello, delay world!</div>')}catch(b){a.fail()}}),test('cached renderd html with custom TTL',async(a)=>{try{const b=new Map,c=1e4,d=ntml({cacheStore:b,cacheName:'test',cacheExpiry:c}),e=3e3,f=async()=>new Promise((a)=>setTimeout(()=>a('Hello, delay world!'),e)),g=()=>d`<div>${f}</div>`,h=process.hrtime(),i=await g(),j=process.hrtime(h),k=process.hrtime(),l=await new Promise((a)=>setTimeout(async()=>a((await g())),c+e)),m=process.hrtime(k);console.log('#',toMs(j),toMs(m)),a.true('string'==typeof i),a.true(toMs(j)>=e),a.is(i,'<div>Hello, delay world!</div>'),a.true(toMs(m)>=c+e),a.is(l,'<div>Hello, delay world!</div>')}catch(b){a.fail()}}),test('render minified html',async(a)=>{try{const b=ntml({minify:!0}),c=await b`
    <div>
      <h1>Hello, World!</h1>
      <ul>
        <li>One</li>
        <li>Two</li>
        <li>Three</li>
      </ul>
    </div>
    `;a.true('string'==typeof c),a.is(c,'<div><h1>Hello, World!</h1><ul><li>One</li><li>Two</li><li>Three</li></ul></div>')}catch(b){a.fail()}});